Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt
Class AlphaComposite

    java.lang.Object
      |
      +--java.awt.AlphaComposite

All Implemented Interfaces:
  Composite

public final class AlphaComposite
extends Object
implements Composite

This `AlphaComposite` class implements the basic alpha compositing rules for combining source and destination pixels to achieve blending and transparency effects with graphics and images. The rules implemented by this class are a subset of the Porter-Duff rules described in T. Porter and T. Duff, "Compositing Digital Images", SIGGRAPH 84, 253-259.

If any input does not have an alpha channel, an alpha value of 1.0, which is completely opaque, is assumed for all pixels. A constant alpha value can also be specified to be multiplied with the alpha value of the source pixels.

The following abbreviations are used in the description of the rules:

- Cs = one of the color components of the source pixel.
- Cd = one of the color components of the destination pixel.
- As = alpha component of the source pixel.
- Ad = alpha component of the destination pixel.
- Fs = fraction of the source pixel that contributes to the output.
- Fd = fraction of the input destination pixel that contributes to the output.

The color and alpha components produced by the compositing operation are calculated as follows:

     	Cd = Cs*Fs + Cd*Fd
     	Ad = As*Fs + Ad*Fd

where Fs and Fd are specified by each rule. The above equations assume that both source and destination pixels have the color components premultiplied by the alpha component. Similarly, the equations expressed in the definitions of compositing rules below assume premultiplied alpha.

For performance reasons, it is preferrable that Rasters passed to the compose method of a `CompositeContext` object created by the `AlphaComposite` class have premultiplied data. If either source or destination Rasters are not premultiplied, however, appropriate conversions are performed before and after the compositing operation.

The alpha resulting from the compositing operation is stored in the destination if the destination has an alpha channel. Otherwise, the resulting color is divided by the resulting alpha before being stored in the destination and the alpha is discarded. If the alpha value is 0.0, the color values are set to 0.0.

See Also:
  `Composite`, `CompositeContext`

Field Summary
`static AlphaComposite` | `Clear` `AlphaComposite` object that implements the opaque CLEAR rule with an alpha of 1.0f.
`static int` | `CLEAR` Porter-Duff Clear rule.
`static int` | `DST_IN` Porter-Duff Destination In Source rule.
`static int` | `DST_OUT` Porter-Duff Destination Held Out By Source rule.
`static int` | `DST_OVER` Porter-Duff Destination Over Source rule.
`static AlphaComposite` | `DstIn` `AlphaComposite` object that implements the opaque DST_IN rule with an alpha of 1.0f.
`static AlphaComposite` | `DstOut` `AlphaComposite` object that implements the opaque DST_OUT rule with an alpha of 1.0f.
`static AlphaComposite` | `DstOver` `AlphaComposite` object that implements the opaque DST_OVER rule with an alpha of 1.0f.
`static AlphaComposite` | `Src` `AlphaComposite` object that implements the opaque SRC rule with an alpha of 1.0f.
`static int` | `SRC` Porter-Duff Source rule.
`static int` | `SRC_IN` Porter-Duff Source In Destination rule.
`static int` | `SRC_OUT` Porter-Duff Source Held Out By Destination rule.
`static int` | `SRC_OVER` Porter-Duff Source Over Destination rule.
`static AlphaComposite` | `SrcIn` `AlphaComposite` object that implements the opaque SRC_IN rule with an alpha of 1.0f.
`static AlphaComposite` | `SrcOut` `AlphaComposite` object that implements the opaque SRC_OUT rule with an alpha of 1.0f.
`static AlphaComposite` | `SrcOver` `AlphaComposite` object that implements the opaque SRC_OVER rule with an alpha of 1.0f.

Method Summary
`CompositeContext` | `createContext(ColorModel srcColorModel, ColorModel dstColorModel, RenderingHints hints)` Creates a context for the compositing operation.
`boolean` | `equals(Object obj)` Tests if the specified `Object` is equal to this `AlphaComposite` object.
`float` | `getAlpha()` Returns the alpha value of this`AlphaComposite`.
`static AlphaComposite` | `getInstance(int rule)` Creates an `AlphaComposite` object with the specified rule.
`static AlphaComposite` | `getInstance(int rule, float alpha)` Creates an `AlphaComposite` object with the specified rule and the constant alpha to multiply with the alpha of the source.
`int` | `getRule()` Returns the compositing rule of this `AlphaComposite`.
`int` | `hashCode()` Returns the hashcode for this composite.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### CLEAR

    public static final int CLEAR

  Porter-Duff Clear rule. Both the color and the alpha of the destination are cleared. Neither the source nor the destination is used as input.

  Fs = 0 and Fd = 0, thus:

       	Cd = 0
       	Ad = 0

### SRC

    public static final int SRC

  Porter-Duff Source rule. The source is copied to the destination. The destination is not used as input.

  Fs = 1 and Fd = 0, thus:

       	Cd = Cs
       	Ad = As

### SRC_OVER

    public static final int SRC_OVER

  Porter-Duff Source Over Destination rule. The source is composited over the destination.

  Fs = 1 and Fd = (1-As), thus:

       	Cd = Cs + Cd*(1-As)
       	Ad = As + Ad*(1-As)

### DST_OVER

    public static final int DST_OVER

  Porter-Duff Destination Over Source rule. The destination is composited over the source and the result replaces the destination.

  Fs = (1-Ad) and Fd = 1, thus:

       	Cd = Cs*(1-Ad) + Cd
       	Ad = As*(1-Ad) + Ad

### SRC_IN

    public static final int SRC_IN

  Porter-Duff Source In Destination rule. The part of the source lying inside of the destination replaces the destination.

  Fs = Ad and Fd = 0, thus:

       	Cd = Cs*Ad
       	Ad = As*Ad

### DST_IN

    public static final int DST_IN

  Porter-Duff Destination In Source rule. The part of the destination lying inside of the source replaces the destination.

  Fs = 0 and Fd = As, thus:

       	Cd = Cd*As
       	Ad = Ad*As

### SRC_OUT

    public static final int SRC_OUT

  Porter-Duff Source Held Out By Destination rule. The part of the source lying outside of the destination replaces the destination.

  Fs = (1-Ad) and Fd = 0, thus:

       	Cd = Cs*(1-Ad)
       	Ad = As*(1-Ad)

### DST_OUT

    public static final int DST_OUT

  Porter-Duff Destination Held Out By Source rule. The part of the destination lying outside of the source replaces the destination.

  Fs = 0 and Fd = (1-As), thus:

       	Cd = Cd*(1-As)
       	Ad = Ad*(1-As)

### Clear

    public static final AlphaComposite Clear

  `AlphaComposite` object that implements the opaque CLEAR rule with an alpha of 1.0f.
  See Also:
    `CLEAR`

### Src

    public static final AlphaComposite Src

  `AlphaComposite` object that implements the opaque SRC rule with an alpha of 1.0f.
  See Also:
    `SRC`

### SrcOver

    public static final AlphaComposite SrcOver

  `AlphaComposite` object that implements the opaque SRC_OVER rule with an alpha of 1.0f.
  See Also:
    `SRC_OVER`

### DstOver

    public static final AlphaComposite DstOver

  `AlphaComposite` object that implements the opaque DST_OVER rule with an alpha of 1.0f.
  See Also:
    `DST_OVER`

### SrcIn

    public static final AlphaComposite SrcIn

  `AlphaComposite` object that implements the opaque SRC_IN rule with an alpha of 1.0f.
  See Also:
    `SRC_IN`

### DstIn

    public static final AlphaComposite DstIn

  `AlphaComposite` object that implements the opaque DST_IN rule with an alpha of 1.0f.
  See Also:
    `DST_IN`

### SrcOut

    public static final AlphaComposite SrcOut

  `AlphaComposite` object that implements the opaque SRC_OUT rule with an alpha of 1.0f.
  See Also:
    `SRC_OUT`

### DstOut

    public static final AlphaComposite DstOut

  `AlphaComposite` object that implements the opaque DST_OUT rule with an alpha of 1.0f.
  See Also:
    `DST_OUT`

Method Detail

### getInstance

    public static AlphaComposite getInstance(int rule)

  Creates an `AlphaComposite` object with the specified rule.
  Parameters:
    `rule` - the compositing rule
  Throws:
    `IllegalArgumentException` - if `rule` is not one of the following: `CLEAR`, `SRC`, `SRC_OVER`, `DST_OVER`, `SRC_IN`, `DST_IN`, `SRC_OUT`, or `DST_OUT`

### getInstance

    public static AlphaComposite getInstance(int rule,
                                             float alpha)

  Creates an `AlphaComposite` object with the specified rule and the constant alpha to multiply with the alpha of the source. The source is multiplied with the specified alpha before being composited with the destination.
  Parameters:
    `rule` - the compositing rule
    `alpha` - the constant alpha to be multiplied with the alpha of the source. `alpha` must be a floating point number in the inclusive range [0.0, 1.0].

### createContext

    public CompositeContext createContext(ColorModel srcColorModel,
                                          ColorModel dstColorModel,
                                          RenderingHints hints)

  Creates a context for the compositing operation. The context contains state that is used in performing the compositing operation.
  Specified by:
    `createContext` in interface `Composite`
  Parameters:
    `srcColorModel` - the `ColorModel` of the source
    `dstColorModel` - the `ColorModel` of the destination
  Returns:
    the `CompositeContext` object to be used to perform compositing operations.

### getAlpha

    public float getAlpha()

  Returns the alpha value of this`AlphaComposite`. If this `AlphaComposite` does not have an alpha value, 1.0 is returned.
  Returns:
    the alpha value of this `AlphaComposite`.

### getRule

    public int getRule()

  Returns the compositing rule of this `AlphaComposite`.
  Returns:
    the compositing rule of this `AlphaComposite`.

### hashCode

    public int hashCode()

  Returns the hashcode for this composite.
  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code for this composite.

### equals

    public boolean equals(Object obj)

  Tests if the specified `Object` is equal to this `AlphaComposite` object.
  Overrides:
    `equals` in class `Object`
  Parameters:
    `obj` - the `Object` to test for equality
  Returns:
    `true` if `obj` equals this `AlphaComposite`; `false` otherwise.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.